diff --git a/examples/qt/shapes/mainwindow.cpp b/examples/qt/shapes/mainwindow.cpp
index d570d36..e812cd0 100644
--- a/examples/qt/shapes/mainwindow.cpp
+++ b/examples/qt/shapes/mainwindow.cpp
@@ -141,10 +141,12 @@ void MainWindow::addRegularPolygon()
     item->setBrush(colorForX(itemCount));
     item->setPen(Qt::NoPen);
     item->setPos(offset.x(), offset.y());
-    addItem(item);
+    item->setObjectName(QString("Polygon:%1").arg(itemCount));
+    addItem(static_cast<QGraphicsObject*>(item));
 }
 
 
+
 void MainWindow::addText()
 {
     bool ok;
diff --git a/examples/qt/shapes/regularpolygonitem.cpp b/examples/qt/shapes/regularpolygonitem.cpp
index 72c37c5..b4638a0 100644
--- a/examples/qt/shapes/regularpolygonitem.cpp
+++ b/examples/qt/shapes/regularpolygonitem.cpp
@@ -12,7 +12,7 @@
 
 
 RegularPolygonItem::RegularPolygonItem(QGraphicsItem *parent)
-    : QObject(), QGraphicsPolygonItem(parent)
+    : QGraphicsObject(NULL), QGraphicsPolygonItem(parent)
 {
     setRegularPolygon(Triangle);
 }
@@ -25,6 +25,7 @@ void RegularPolygonItem::setRegularPolygon(RegularPolygon regularPolygon)
     if (m_regularPolygon == Triangle) {
         polygon << QPointF(-50.0, 50.0) << QPointF(0.0, -50.0)
                 << QPointF(50.0, 50.0);
+
     }
     else if (m_regularPolygon == Square) {
         polygon << QPointF(-50.0, -50.0) << QPointF(-50.0, 50.0)
diff --git a/examples/qt/shapes/regularpolygonitem.h b/examples/qt/shapes/regularpolygonitem.h
index 5b1bd57..a396561 100644
--- a/examples/qt/shapes/regularpolygonitem.h
+++ b/examples/qt/shapes/regularpolygonitem.h
@@ -12,7 +12,7 @@
 #include <qgraphicssceneevent.h>
 
 
-class RegularPolygonItem : public QObject, public QGraphicsPolygonItem
+class RegularPolygonItem : public QGraphicsObject, public QGraphicsPolygonItem
 {
     Q_OBJECT
     Q_ENUMS(RegularPolygon)
@@ -22,6 +22,23 @@ public:
 
     RegularPolygonItem(QGraphicsItem *parent=0);
 
+    QRectF boundingRect() const {
+        return QGraphicsPolygonItem::boundingRect();
+    }
+    void paint(QPainter* painter, const QStyleOptionGraphicsItem* sogi, QWidget* w) {
+        return QGraphicsPolygonItem::paint(painter, sogi, w);
+    }
+    QPainterPath shape() const {
+        return QGraphicsPolygonItem::shape();
+    }
+    int type() const {
+        return QGraphicsPolygonItem::type();
+    }
+    void setPos(float x, float y) {
+        QGraphicsPolygonItem::setPos(x,y);
+        QGraphicsObject::setPos(x,y);
+    }
+
     RegularPolygon regularPolygon() const { return m_regularPolygon; }
 
 public slots:
